/*************************************************************************
 *
 *    Used with ICCARM and AARM.
 *
 *    (c) Copyright IAR Systems 2005
 *
 *    File name   : scsi_desc.h
 *    Description : SCSI descriptor definitions
 *
 *    History :
 *    1. Data        : September 13, 2005
 *       Author      : Stanimir Bonev
 *       Description : Create
 *
 *    $Revision: 1.2.2.1 $
**************************************************************************/
#include <includes.h>

#ifndef __SCSI_DESC_H
#define __SCSI_DESC_H

typedef enum
{
  DeviceIsConnectedToLU = 0,DeviceIsNotConnectedToLU, Reserved,
  NotSuportPhysicalDevice,
} SpcPeripheralQualifier_t;

typedef enum
{
  SbcDirectAccess = 0, SscSequentialAccess,SSCPrinter,SpcProcessor,
  ScbWriteOnce,Mmc2CDROM,Scsi2Scanner,SbcOpticalMemory,
  SmcMediumChanger,Scsi2Communications,DefinedByASCIT8_1,DefinedByASCIT8_2,
  Scc2StorageArrayController,SesEnclosureServices,RbcSimplifiedDirectAccess,
  OcrwOpticalCardReader,BridgingExpanders,OsdObjectBasedStorage, UnknowType = 0x1F,
} SpcPeripheralDeviceType_t;

#define SpcInquiryRemovableMedium        0x80
#define SpcInquiryNotRemovableMedium     0x00

//  SCSI Primary Commands - 3
#define SpcInquiryStandartVersion        5

#endif //__SCSI_DESC_H
